function draw_tree_svg(what) {
    fdraw_tree_svg("thoughts", what)
}

function fdraw_tree_svg(where, what) {
    //thoughts_write("<pre>"+what.length+"</pre>")
    height_of_nodes = new Object
    nodes_of_height = new Object
    order_of_nodes = new Object
    max_height = 0
    max_width = 0
    for(var i in what) {
        w = what[i]
        c = w
        height = 0
        while(c.parent) {
            c = c.parent
            height++
        }
        height_of_nodes[i] = height
        if(nodes_of_height[height] == undefined) {
            nodes_of_height[height] = []
        }
        nodes_of_height[height].push(i)
        max_height = max_height > height ? max_height : height
    }
    for(var i in nodes_of_height) {
        width = nodes_of_height[i].length
        max_width = max_width > width ? max_width : width
    }
    for(var i in nodes_of_height) {
        current_row = nodes_of_height[i]
        for(var ii in current_row) {
            current_node = current_row[ii]
            order_of_nodes[current_node] = ii
        }
    }
    
    var scale = 10 //10 to 20 seems to work best
    var fatness = 1.2 //2.0 is twice fat and 0.5 is half thin
    var tallness = 0.7 //2.0 is twice tall and 0.5 is half short
    
    total_height = (max_height +2) * (scale*4*tallness)
    total_width = (max_width +2) * (scale*4*fatness)
    
    t  = "<div style='text-align:center'>";
    t += "<svg id='phylotree' xmlns='http://www.w3.org/2000/svg' width='"+total_width+"' height='"+total_height+"'\n"
    t += "xmlns:xlink='http://www.w3.org/1999/xlink'>\n"
    for(var i = 0; i < max_height+1; i ++) {
        current_row = nodes_of_height[i]
        for(var ii = 0; ii < current_row.length; ii ++) {
            //thoughts_write("<pre>"+i+" : "+ii+"</pre>")
            current_node = current_row[ii]
            xlocation = (total_width/2) - ((scale*2*fatness) * current_row.length) + (scale*4*fatness) * ii
            ylocation = (i * (scale*4*tallness) + (scale*2))
            if(what[current_node].left) {
                //already have parent x, y locations
                //get child x,y locations...
                lchildx = (total_width/2) - ((scale*2*fatness) * nodes_of_height[i+1].length) + (scale*4*fatness) * order_of_nodes[what[current_node].left.serial]
                lchildy = ((i+1) * (scale*4*tallness) + (scale*2))
                //thoughts_write("<pre>L " + xlocation + " " + ylocation + " " + lchildx + " " + lchildy + "</pre>")
                t += "<path d='M"+xlocation+" "+ylocation+" L" + lchildx + " " + lchildy + "'\n"
                t += "style='fill:white;stroke:black;stroke-width:"+(scale*0.15)+"'\n"
                t += "/>\n"
            }
            if(what[current_node].right) {
                rchildx = (total_width/2) - ((scale*2*fatness) * nodes_of_height[i+1].length) + (scale*4*fatness) * order_of_nodes[what[current_node].right.serial]
                rchildy = ((i+1) * (scale*4*tallness) + (scale*2))
                //thoughts_write("<pre>R " + xlocation + " " + ylocation + " " + rchildx + " " + rchildy + "</pre>")
                t += "<path d='M"+xlocation+" "+ylocation+" L" + rchildx + " " + rchildy + "'\n"
                t += "style='fill:white;stroke:black;stroke-width:"+(scale*0.15)+"'\n"
                t += "/>\n"
            }
            t += "<a xlink:href='#' onclick='javascript:select_node(\""+current_node+"\")'>\n"
            t += "<circle cx='"+xlocation+"' cy='"+ylocation+"' r='"+(scale)+"' id='phylo_node_"+current_node+"'\n"
            t += "style='fill:white;stroke:black;stroke-width:"+(scale*0.15)+"'\n"
            t += "/>\n"
            t += "<text style='font-family:monospace;font-weight:bold;font-size:"+(scale*0.75)+"pt;' x='"+(xlocation-5)+"' y='"+(ylocation+5)+"'>"+what[current_node].serial+"</text>"
            t += "</a>\n"
        }
    }
    t += "</svg></div>"
    fthoughts_overwrite(where, t)
}

// We assume that the JS variable "traverse" is ready.
// We assume that fdraw_tree_svg created the ids = {phylotree, [phylo_node_0, phylo_node_1 ... phylo_node_#{n-1}]}
var _undo_render_hash = new Object
function select_node(which) {
    
    thoughts_overwrite("")
    
    var message = ""
    message += node_expose(traverse[which])
    message += "<pre>"
    var inner_traverse = tree_traversal(traverse[which])
    var gapped_seq = new Object()
    for(var it in inner_traverse) {
        if(fasta_dict[inner_traverse[it].name]) {
            gapped_seq[inner_traverse[it].serial] = fasta_dict[inner_traverse[it].name]
        }
    }
    stripped_seq = strip_gaps(gapped_seq)
    for(var it in inner_traverse) {
        if(fasta_dict[inner_traverse[it].name]) {
            message +=
                "<a href = \"#\" onclick='javascript:select_node(\""+inner_traverse[it].serial+"\")'>" +
                number_pad(inner_traverse[it].serial, 2) +
                "</a>" + ": " + stripped_seq[inner_traverse[it].serial] + "\n"
        }
    }
    message += "</pre>"
    
    thoughts_write(message)
    //thoughts_overwrite(message)
    
    for(var i in _undo_render_hash) {
        document.getElementById(i).setAttribute("style", _undo_render_hash[i])
    }
    _undo_render_hash = new Object
    
    var current_node = document.getElementById("phylo_node_" + which)
    _undo_render_hash["phylo_node_" + which] = current_node.getAttribute("style")
    current_node.setAttribute("style", "fill:#AFA;stroke:black;")
}

function strip_gaps(gapped_seq) {
    var retObj = new Object()
    var gaps = new Object()
    for(var gs in gapped_seq) {
        for(var ch in gapped_seq[gs]) {
            if(gapped_seq[gs][ch] != "-")
                gaps[ch] = true
        }
    }
    for(var gs in gapped_seq) {
        var currentSeq = ""
        for(var ch in gapped_seq[gs]) {
            if(gaps[ch]) {
                currentSeq += gapped_seq[gs][ch]
            }
        }
        retObj[gs] = currentSeq
    }
    return retObj
}

function number_pad(v, vlen) {
    var i = 0
    var retObj = "" + v
    while(retObj.length < vlen ) {
        retObj = "0" + retObj
    }
    return retObj
}

function get_spiked_name(node) {
    var spiked_name = undefined
    if(node.name != undefined && node.name.match("[|]")) {
        var splitted = node.name.split("|")
        var gi_number = undefined
        var pdb_id = undefined
        for(sp in splitted) {
            if(sp > 0) {
                if(splitted[sp -1] == "gi") {
                    gi_number = splitted[sp]
                }
                if(splitted[sp -1] == "pdb") {
                    pdb_id = splitted[sp]
                }
            }
        }
        spiked_name = "" + node.name
        if(gi_number) {
            spiked_name = spiked_name.replace("gi|"+gi_number, "<a href=\"http://www.ncbi.nlm.nih.gov/protein/"+gi_number+"\">gi|"+gi_number+"</a>")
        }
        if(pdb_id) {
            spiked_name = spiked_name.replace("pdb|"+pdb_id, "<a href=\"http://www.pdb.org/pdb/explore/explore.do?structureId="+pdb_id+"\">pdb|"+pdb_id+"</a>")
        }
    }
    return spiked_name
}

function get_image_name(node) {
    var image_name = undefined
    if(node.name != undefined && node.name.match("[|]")) {
        var splitted = node.name.split("|")
        var pdb_id = undefined
        for(sp in splitted) {
            if(sp > 0) {
                if(splitted[sp -1] == "pdb") {
                    pdb_id = splitted[sp]
                }
            }
        }
        if(pdb_id) {
            image_name = "<img src=\"http://www.pdb.org/pdb/images/"+pdb_id+"_bio_r_500.jpg\" width=\"120\" border=\"1\"/>"
        }
    }
    return image_name
}

function node_expose(node) {
    var thoughts = ""
    var name = get_spiked_name(node) || node.name || undefined
    thoughts += ("<h3 style=\"font-family:monospace\">")
    thoughts += "Node " + (number_pad(node.serial, 2) + (name ? " : " : ""))
    thoughts += (name || "")
    thoughts += ("</h3>")
    thoughts += ("<ul style=\"font-family:monospace\">")
    thoughts += get_image_name(node) || ""
    if(node.parent) {
        var name = get_spiked_name(node.parent) || node.parent.name || undefined
        thoughts += ("<li><a href=\"#\" onclick='javascript:select_node(\""+node.parent.serial+"\")'>"+"parent node:"+"</a> ")
        thoughts += (number_pad(node.parent.serial, 2) + (name ? " : " : ""))
        thoughts += ((name || "") + "</li>")
    }
    if(node.left) {
        var name = get_spiked_name(node.left) || node.left.name || undefined
        thoughts += ("<li><a href=\"#\" onclick='javascript:select_node(\""+node.left.serial+"\")'>"+"left child node:"+"</a> ")
        thoughts += (number_pad(node.left.serial, 2) + (name ? " : " : ""))
        thoughts += ((name || "") + "</li>")
    }
    if(node.right) {
        var name = get_spiked_name(node.right) || node.right.name || undefined
        thoughts += ("<li><a href=\"#\" onclick='javascript:select_node(\""+node.right.serial+"\")'>"+"right child node:"+"</a> ")
        thoughts += (number_pad(node.right.serial, 2) + (name ? " : " : ""))
        thoughts += ((name || "") + "</li>")
    }
    if(node.branch_length) {
        thoughts += ("<li>branch_length: " + node.branch_length + "</li>");
    }
    thoughts += ("</ul>")
    return thoughts
}
