import sys

try:
    fasta = open(sys.argv[1], "r")
    newick = open(sys.argv[2], "r")
    title = sys.argv[3]
except:
    sys.stderr.write("Usage: <fasta file> <newick file> <title>\n")
    exit(0)

sys.stdout.write(
"""
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>
"""+title+"""
</title>
</head>
<body>
<div id="tree_display"></div>
<div id="thoughts"></div>
<script type="text/javascript" src="parse_newick_xhtml.js"></script>
<script type="text/javascript" src="draw_phylogeny.js"></script>
<script type="text/javascript">
var fasta_dict = new Object()
"""
)

def write_fasta_dict(header, body):
    sys.stdout.write("fasta_dict[\""+header+"\"] = \""+body+"\"\n")

with fasta as f:
    header = ""
    body = ""
    for iline, line in enumerate(f):
        line = line[:-1]
        if line[0] == ">":
            if iline == 0:
                header = line[1:].strip()
                continue
            write_fasta_dict(header, body)
            header = line[1:].strip()
            body = ""
        else:
            body += line.strip().upper()
    write_fasta_dict(header, body)

with newick as n:
    traversal = ""
    for line in n:
        line = line[:-1]
        traversal += line
    sys.stdout.write("var newick_string = \""+traversal+"\"\n")

sys.stdout.write(
"""
var tree_structure = new tree_builder(newick_string)
var traverse = tree_traversal(tree_structure)
fdraw_tree_svg("tree_display", traverse)
//tree_expose(tree_structure)
</script>
</body>
</html>
"""
)
